unit Unit5;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, ExtCtrls,
  UnitV ;

type
  TForm5 = class(TForm)
    SG1: TStringGrid;
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Panel1: TPanel;
    Label3: TLabel;
    Label4: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Label2: TLabel;
    Edit3: TEdit;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SG1Click(Sender: TObject);
    procedure Edit1DblClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private 錾 }
    procedure TableDisplay ;
  public
    { Public 錾 }
  end;

var
  Form5: TForm5;

implementation

uses
   Unit1 ;

{$R *.dfm}

// N
procedure TForm5.FormShow(Sender: TObject);
var
   i : integer ;
begin
   with SG1 do begin
      RowCount := 2 ;
      Cells[0,0] := 'ԍ';
      Cells[1,0] := '';
      Cells[2,0] := 'ۖ';
      for i:=0 to ColCount-1 do
         Cells[i,1] := '' ;
   end;
   if (Trim(DBfold) = '')or(Trim(DBname) = '') then begin
      ShowMessage('ŏɃf[^x[X̐ݒsĉB');
      close ;
      exit ;
   end;
   // ڑ`FbNiꉞj
   if not(Form1.IBDatabase1.Connected) then begin
      ShowMessage('f[^x[Xɐڑo܂BݒmFĉB');
      close ;
      exit ;
   end;
   // e[u Form1 ĂяoOɍ쐬ς

   // e[uQƁEꗗ\
   TableDisplay ;

   SG1.SetFocus ;
end;

// I
procedure TForm5.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   //
end;

// e[uQƁEꗗ\
procedure TForm5.TableDisplay ;
var
   i,j,n : integer ;
   s : array of string ;
begin
   SG1.RowCount := 2 ;
   for i:=0 to SG1.ColCount-1 do
      SG1.Cells[i,1] := '' ;

   n := Form1.TableRef('*',TABLE3,'','N');
   if (n > 0) then
      SG1.RowCount := n+1 ;

   SetLength(s,TABLE3N);

   for i:=1 to n do begin
      with SG1 do begin
         if (i = 1) then
            Form1.TableFirst(s)
         else
            Form1.TableNext(s);
         for j:=0 to TABLE3N-1 do
            Cells[j,i] := s[j] ;
      end;
   end;
   Form1.TableClose ;

   s := nil;
end;

// \NbN
procedure TForm5.SG1Click(Sender: TObject);
var
   i : integer ;
   s : string ;
begin
   i := SG1.Row ;
   s := SG1.Cells[0,i] ;
   if (s = '') then exit ;
   Edit1.Text := s ;
   Edit2.Text := SG1.Cells[1,i] ;
   Edit3.Text := SG1.Cells[2,i] ;
end;

// ԍŃ_uNbNŏIԍ+1
procedure TForm5.Edit1DblClick(Sender: TObject);
var
   n : integer ;
begin
   n := SInt(Form1.GetMaxValue(TABLE3,'N',''));
   Edit1.Text := IntToStr(n+1);
end;

// o^
procedure TForm5.Button1Click(Sender: TObject);
var
   n,i : integer ;
   fs: array of string ;
   s : array of string ;
begin
   if (Trim(Edit1.Text) = '') then begin
      ShowMessage('ԍ͂ĉi̐ĺj');
      Edit1.SetFocus ;
      exit ;
   end;
   n := SInt(Edit1.Text) ;
   if (n <= 0) then begin
      ShowMessage('ԍ͐̐œ͂ĉ');
      Edit1.SetFocus ;
      exit ;
   end;

   SetLength(fs,TABLE3N);
   SetLength(s ,TABLE3N);

   fs[0] := 'N';
   fs[1] := 'CNAME';
   fs[2] := 'BNAME';

   s[0] := IntToStr(n) ;
   s[1] := Edit2.Text ;
   s[2] := Edit3.Text ;

   for i:=1 to 2 do begin
      if (AnsiPos('''',s[i]) > 0) or (AnsiPos('"',s[i]) > 0) then begin
         fs := nil ;
         s  := nil ;
         ShowMessage('pu''vu"v͂Ȃŉ');
         Edit2.SetFocus;
         exit;
      end;
   end;
   for i:=1 to 2 do begin
      if (s[i] = '') then
         s[i] := 'NULL'
      else
         s[i] := '''' + s[i] + '''' ;
   end;

   if (Form1.TableAdd(TABLE3,TABLE3N,fs,s)) then begin
      ShowMessage('o^OK');
   end
   else begin
      ShowMessage('o^s');
   end;

   fs := nil ;
   s  := nil ;

   TableDisplay ;
end;

// 폜
procedure TForm5.Button2Click(Sender: TObject);
var
   i : integer ;
   s : string ;
begin
   i := SG1.Row ;
   s := SG1.Cells[0,i] ;
   if (s = '') then exit ;
   s := 'No.' + s + 'F' + SG1.Cells[1,i] + '|' + SG1.Cells[2,i] ;
   if MessageDlg('u'+s+'v폜܂B' + #13 + #10 + '낵łH',
      mtConfirmation, [mbYes, mbNo], 0) = mrNo then exit ;
   //
   s := SG1.Cells[0,i] ;
   i := SInt(s);
   if (Form1.TableDel(TABLE3,'N='+IntToStr(i))) then begin
      ShowMessage('폜OK');
   end
   else begin
      ShowMessage('폜s');
   end;
   //
   TableDisplay ;
end;

// 
procedure TForm5.Button3Click(Sender: TObject);
begin
   close;
end;

// ύX
procedure TForm5.Button4Click(Sender: TObject);
var
   n,i : integer ;
   fs: array of string ;
   s : array of string ;
   w : string ;
begin
   if (Trim(Edit1.Text) = '') then begin
      ShowMessage('ԍ͂ĉi̐ĺj');
      Edit1.SetFocus ;
      exit ;
   end;
   n := SInt(Edit1.Text) ;
   if (n <= 0) then begin
      ShowMessage('ԍ͐̐œ͂ĉ');
      Edit1.SetFocus ;
      exit ;
   end;
   //
   // f[^`FbN
   if not(Form1.CheckValue(TABLE3,'N','', n)) then begin
      ShowMessage('͂ԍ͖gpł̂ŕύX͏o܂Bē͂ĉ');
      Edit1.SetFocus ;
      exit ;
   end ;
   //
   SetLength(fs,TABLE3N);
   SetLength(s ,TABLE3N);

   fs[0] := 'N';
   fs[1] := 'CNAME';
   fs[2] := 'BNAME';

   s[0] := IntToStr(n) ;
   s[1] := Edit2.Text ;
   s[2] := Edit3.Text ;

   for i:=1 to 2 do begin
      if (AnsiPos('''',s[i]) > 0) or (AnsiPos('"',s[i]) > 0) then begin
         fs := nil ;
         s  := nil ;
         ShowMessage('pu''vu"v͂Ȃŉ');
         Edit2.SetFocus;
         exit;
      end;
   end;
   for i:=1 to 2 do begin
      if (s[i] = '') then
         s[i] := 'NULL'
      else
         s[i] := '''' + s[i] + '''' ;
   end;

   w := 'N=' + IntToStr(n) ;

   if (Form1.TableEdit(TABLE3,TABLE3N,fs,s,w)) then begin
      ShowMessage('ύXOK');
   end
   else begin
      ShowMessage('ύXs');
   end;

   fs := nil ;
   s  := nil ;

   TableDisplay ;
end;

end.
