unit Unit8;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, ExtCtrls,  StdCtrls, ComCtrls,
  UnitV, Unit7, Unit10 ;

type
  TForm8 = class(TForm)
    Panel1: TPanel;
    SG1: TStringGrid;
    Panel2: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    Edit1: TEdit;
    Label4: TLabel;
    Edit2: TEdit;
    Label5: TLabel;
    Edit3: TEdit;
    Label6: TLabel;
    Edit4: TEdit;
    Label7: TLabel;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Label8: TLabel;
    Label11: TLabel;
    Label14: TLabel;
    Edit9: TEdit;
    Splitter1: TSplitter;
    Edit10: TEdit;
    Edit11: TEdit;
    Label3: TLabel;
    Edit12: TEdit;
    CheckBox1: TCheckBox;
    Edit8: TEdit;
    Label9: TLabel;
    LabelA: TLabel;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure ComboBox1Select(Sender: TObject);
    procedure ComboBox2Select(Sender: TObject);
    procedure SG1SelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure SG1DblClick(Sender: TObject);
    procedure Button8Click(Sender: TObject);
  private
    { Private 錾 }
    n,n1,n2 : integer ;
    wh1,od1 : string ;
    procedure SCellClear ;
    procedure SCellDisplay ;
  public
    { Public 錾 }
  end;

var
  Form8: TForm8;

implementation

uses
   Unit1 ;

{$R *.dfm}

// J
procedure TForm8.FormShow(Sender: TObject);
var
   i : integer ;
begin
   Width  := Fm8_w ;
   Height := Fm8_h ;
   for i:=0 to 5 do
      SG1.ColWidths[i] := Fm8_c[i] ;
   Panel1.Height := Fm8_p1h ;
   //
   n  := 100 ;    // 1y[W̃f[^
   n1 := 1 ;      // 擪R[hԍ
   n2 := 0 ;      // ł̃R[hԍ
   wh1:= '';      // WHERE߁ii荞ݗpj
   od1:= 'N';     // ORDER BYiяpj
   //
   with SG1 do begin
      Cells[0,0] := 'ԍ' ;
      Cells[1,0] := 'vWFNg' ;
      Cells[2,0] := '\' ;
      Cells[3,0] := '[' ;
      Cells[4,0] := '[it' ;
      Cells[5,0] := '' ;
      RowCount := n + 1;
   end;
   SCellClear ;
   Button1.SetFocus ;
end;

// 
procedure TForm8.FormClose(Sender: TObject; var Action: TCloseAction);
var
   i : integer ;
begin
   Fm8_w := Width ;
   Fm8_h := Height ;
   for i:=0 to 5 do
      Fm8_c[i] := SG1.ColWidths[i] ;
   Fm8_p1h := Panel1.Height ;

   Action := caFree ;
end;

// eNA
procedure TForm8.SCellClear ;
var
   i,j : integer ;
begin
   with SG1 do begin
      for j:=1 to RowCount-1 do
         for i:=0 to ColCount-1 do
            Cells[i,j] := '';
   end;
end;

// f[^ǂݍ
procedure TForm8.SCellDisplay ;
var
   i,j : integer ;
begin
   with Form1 do begin
      IBQuery1.Active := False ;
      IBTransaction1.Active := False ;
      IBQuery1.ParamCheck := True ;
      with IBQuery1.SQL do begin
         Clear ;
         Add('SELECT * FROM '+TABLE4);
         if (wh1 <> '') then begin
            Add('  WHERE ' + wh1);
         end;
         Add('  ORDER BY ' + od1 + ';');
      end;
      j := 1 ;
      //
      try
         IBQuery1.Open ;
         IBQuery1.First ;
         if (n1 > 1) then IBQuery1.MoveBy(n1-1);
         while not(IBQuery1.Eof) do begin
            SG1.Cells[0,j] := IBQuery1.FieldByName('N').AsString ;
            SG1.Cells[1,j] := IBQuery1.FieldByName('PRNAME').AsString ;
            SG1.Cells[2,j] := IBQuery1.FieldByName('MTITLE').AsString ;
            SG1.Cells[3,j] := IBQuery1.FieldByName('NOUKI').AsString ;
            SG1.Cells[4,j] := IBQuery1.FieldByName('NDATE').AsString ;
            i := IBQuery1.FieldByName('ENDF').AsInteger ;
            if (i = 0) then
               SG1.Cells[5,j] := ''
            else
               SG1.Cells[5,j] := '';

            Inc(j);
            if (j > n) then break ;
            IBQuery1.Next ;
         end;
      except
         ;
      end;
      IBQuery1.Active := False ;
      n2 := n1 + j - 1;
   end;
end;

// ŏ
procedure TForm8.Button1Click(Sender: TObject);
begin
   SCellClear ;
   n1 := 1 ;
   SCellDisplay ;
end;

// O
procedure TForm8.Button2Click(Sender: TObject);
begin
   SCellClear ;
   if (n1 > 1) then begin
      n1 := n1 - n ;
      if (n1 < 1) then n1 := 1 ;
   end;
   SCellDisplay ;
end;

// 
procedure TForm8.Button3Click(Sender: TObject);
begin
   SCellClear ;
   n1 := n2 ;
   SCellDisplay ;
end;

// XV
procedure TForm8.Button4Click(Sender: TObject);
begin
   SCellClear ;
   SCellDisplay ;
end;

// яύX
procedure TForm8.ComboBox1Select(Sender: TObject);
var
   i : integer ;
begin
   i := ComboBox1.ItemIndex ;
   if (i = -1) then exit ;
   Case(i)of
    0:begin // ԍ
         od1 := 'N' ;
      end;
    1:begin // ԍ
         od1 := 'N DESC' ;
      end;
    2:begin // vWFNg
         od1 := 'PRNAME' ;
      end;
    3:begin // vWFNg
         od1 := 'PRNAME DESC' ;
      end;
    4:begin // \聫
         od1 := 'MTITLE' ;
      end;
    5:begin // \聪
         od1 := 'MTITLE DESC' ;
      end;
    6:begin // [
         od1 := 'NOUKI' ;
      end;
    7:begin // [
         od1 := 'NOUKI DESC' ;
      end;
    8:begin // [it
         od1 := 'NDATE' ;
      end;
    9:begin // [it
         od1 := 'NDATE DESC' ;
      end;
   end;

   Button1Click(Sender);   // ŏ
end;

// i荞
procedure TForm8.ComboBox2Select(Sender: TObject);
var
   i : integer ;
   s : string ;
begin
   i := ComboBox2.ItemIndex ;
   if (i = -1) then exit ;
   s := Edit1.Text ;
   if (s = '') then i := 0 ;
   Case(i)of
    0:begin // ij
         wh1 := '';
      end;
    1:begin // vWFNg
         wh1 := 'PRNAME' ;
      end;
    2:begin // \
         wh1 := 'MTITLE' ;
      end;
    3:begin // [
         wh1 := 'NOUKI' ;
      end;
    4:begin // [it
         wh1 := 'NDATE' ;
      end;
   end;

   if (wh1 <> '') then begin
      wh1 := wh1 + ' LIKE ''%' + s + '%''' ;
   end;
   Button1Click(Sender);   // ŏ
end;

// ZI
procedure TForm8.SG1SelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
var
   m,r : integer ;
   s : array of string ;
   w : string ;
begin
   Edit2.Text := '' ;
   Edit3.Text := '' ;
   Edit4.Text := '' ;
   Edit5.Text := '' ;
   Edit6.Text := '' ;
   Edit7.Text := '' ;
   Edit8.Text := '' ;
   Edit9.Text := '' ;
   Edit10.Text := '' ;
   Edit11.Text := '' ;
   Edit12.Text := '' ;
   CheckBox1.Checked := False ;
   LabelA.Caption := '쐬ҁF';

   r := SInt(SG1.Cells[0,ARow]) ;
   if (r <= 0) then exit ;

   SetLength(s ,TABLE4N);

   w := 'N=' + IntToStr(r) ;
   Form1.TableRef('*',TABLE4,w,'');
   Form1.TableFirst(s);
   Form1.TableClose ;

   Edit2.Text  := s[3];
   Edit4.Text  := s[4];
   Edit5.Text  := s[5];
   Edit6.Text  := s[6];
   Edit7.Text  := s[7];
   Edit8.Text  := s[8];
   Edit9.Text  := s[9];
   Edit10.Text := s[10]+'`'+s[11];
   Edit11.Text := s[12]+'`'+s[13];
   Edit12.Text := s[14];
   CheckBox1.Checked := False ;
   if (SInt(s[15]) <> 0) then
      CheckBox1.Checked := True ;

   m := SInt(s[1]) ;
   r := SInt(s[2]) ;
   if (s[0] = '') then begin
      m := 0;
      r := 0;
   end;

   s := nil ;

   // 
   if (r > 0) then begin
      SetLength(s ,TABLE3N);
      w := 'N=' + IntToStr(r) ;
      Form1.TableRef('*',TABLE3,w,'');
      Form1.TableFirst(s);
      Form1.TableClose ;
      Edit3.Text := s[1] + '@' + s[2] ;
      s := nil ;
   end;

   // 쐬
   if (r > 0) then begin
      SetLength(s ,TABLE2N);
      w := 'N=' + IntToStr(m) ;
      Form1.TableRef('*',TABLE2,w,'');
      Form1.TableFirst(s);
      Form1.TableClose ;
      LabelA.Caption := '쐬ҁF'+s[2] ;
      s := nil ;
   end;
end;

// 
procedure TForm8.Button5Click(Sender: TObject);
begin
   Panel1.Height := 172 ;
end;

// 
procedure TForm8.Button6Click(Sender: TObject);
begin
   Panel1.Height := 25 ;
end;

// _uNbN
procedure TForm8.SG1DblClick(Sender: TObject);
var
   n : integer ;
   fm : TForm7 ;
begin
   n := SInt(SG1.Cells[0,SG1.Row]) ;
   if (n <= 0) then exit ;

   S_TYPE := 1 ;
   S_CODE1:= n ;
   try
      fm := TForm7.Create(Application) ;
      fm.Caption := 'vWFNgҏW';
      fm.Show ;
   except
      ;
   end;
end;

// ڍ
procedure TForm8.Button8Click(Sender: TObject);
var
   n : integer ;
   fm : TForm10 ;
begin
   if (Edit2.Text = '') then exit ;
   n := SInt(SG1.Cells[0,SG1.Row]) ;
   if (n <= 0) then exit ;

   S_CODE1 := n ;
   try
      fm := TForm10.Create(Application) ;
      fm.Show ;
   except
      ;
   end;
end;

end.
